do



--##Блок описания вспомогательных функций
	--Выполнение входящего кода <?lua ### ?> с html страницы и возвращение реззультата
	local function executeCode (code)
		--Переназнаяаем стандартную функцию print чтобы не выводилось в консоль, а возвращалось функцией
		local codeOUT
		local oldprint = print
		local newprint = function(...)
			for i,v in ipairs(arg) do
				codeOUT = (codeOUT or "") .. tostring(v)
			end
		end
		print = newprint
		--^^
		--Пытаемся скомпилировать входящий lua код
		local luaFunc, err = loadstring(code)
		if luaFunc ~= nil then
			--Если коспиляция без ошибок, то выполняем входящий lua код
			local status, err = pcall(assert(luaFunc))
			if status == false then
				print("[Runtime error: "..(err or "#err#").."]")
			end
		else
			print("[Syntax error: "..(err or "#err#").."]")
		end
		--^^
		print = oldprint --Возвращаем функцию print
		return codeOUT --возвращаем полученный результат от выполненного lua кода
	end

	-- local function DEBUGPrint(Pre, Str,NilStr) --Функция вывода значений переменных с экранированием nil
	-- 	print("DEBUG"..Pre..NilStr..Pre..Pre.."\n"..(Str or "!"..NilStr.."!").."\n"..Pre..Pre..Pre);
	-- end

	local function escapeMagic(str) --Экранируем все служебные символы
		return string.gsub(str, "[%(%)%.%+%-%*%?%[%]%^%$%%]", "%%%1") --Экранируем все найденные спецсимволы
	end
	local function replace(str, what, with) --Заменяем в строке str найденные what на with
		what = string.gsub(what, "[%(%)%.%+%-%*%?%[%]%^%$%%]", "%%%1") -- escape pattern
		with = string.gsub(with, "[%%]", "%%%%") -- escape replacement
		return string.gsub(str, what, with)
	end


	-- local function responseHeader(code, type) --функция возврата html ответа
	-- 	return "HTTP/1.1 " .. code .. "\r\nContent-Type: " .. type .. "\r\nConnection: close\r\n\r\n";
	-- end
--##^^



	if srv then srv:close() srv=nil end --Если экзземпляр другого web сервера существует, то убиваем его

	srv=net.createServer(net.TCP); --Создаем новый экземпляр TCP сервера

	srv:listen(80,function(conn) --Запускаем сервер на прослушивание TCP:80 и передаем управление соединением в функцию
		local EndPOST = "true"; --Вспомогательная переменная, указывающая, что не ожидается приема следующего блока данных
		local StartPOSTEnd = "false"; --Вспомогательная переменная, указывающая, что при POST приеме блока данных HTML заголовок обработан и далее поступают остальные блоки данных
		local ContentLengthOF = 0; --Вспомогательная переменная для подсчета кол-ва принятых байт данных
		local method = nil;
		local StartPOST = nil;

		conn:on("receive", function(conn,request) --Обработка входящих данных на TCP:80
			local _, _, method, path, vars = string.find(request, "([A-Z]+) (.+)?(.+) HTTP"); --Разбор входящей строки запроса (GET /index.htm?io11=ON, POST)
			if(method == nil)then
				_, _, method, path = string.find(request, "([A-Z]+) (.+) HTTP"); --Разбор входящего запроса GET POST
			end

			if(method == "GET" and EndPOST == "true")then
				print("[GET]"); --DEBUG
				if (vars ~= nil)then --Если иммеются входящие параметры
					for k, v in string.gmatch(vars, "(%w+)=([%w%.~%-_]+)&*") do
						if(k:match("io(%d+)"))then --Если находим io##,то это сигнал к управлению пинами
							print("[Incoming set io " .. k .. "=" .. v .. "]");
							if(v == "ON")then --если ON то "включаем" ## pin
								gpio.write((k:match("io(%d+)") or ""), gpio.HIGH);
							elseif(v == "OFF")then --если OFF то "выключаем" ## pin
								gpio.write((k:match("io(%d+)") or ""), gpio.LOW);
							end
						elseif(k == "command")then --Если находим command,то это сигнал к выполнению предустановленных комманд
							--http://192.168.111.210/?command=###
							if(v == "restart")then
								print("[Restart ESP8266]");
								print("**[Connection closed]");
								node.restart(); --Команда перезагрузки ESP8266
							elseif(v == "delfile")then delfile = "true"; --Предварительно определяемся, что будем УДАЛЯТЬ файл
							elseif(v == "runfile")then runfile = "true"; --Предварительно определяемся, что будем ЗАПУСКАТЬ файл
							elseif(v == "setphymode")then setphymode = "true"; --Предварительно определяемся, что будем устанавливать класс сети WiFi
							elseif(v == "setnullmodesleep")then setnullmodesleep = "true"; --Разрешить автоматически Wi-Fi переходить в режим ожидания (NULL_MODE)
							elseif(v == "setsleeptype")then setsleeptype = "true"; --Тип режима ожидания WiFi
							elseif(v == "freemem")then print("[Free mem on ESP8266]"); collectgarbage(); --Предварительно определяемся, что будем устанавливать класс сети WiFi
							elseif(v == "clearstorewifi")then print("[Clear all stored WiFi AP on Flash]"); wifi.sta.clearconfig(); --Предварительно определяемся, что будем устанавливать класс сети WiFi
							else print("[Unknow incoming command]"); --Выводим предупреждение, что поступила не описанная команда
							end
							--conn:send("HTTP/1.1 204 No Content\r\nConnection: close\r\n\r\n"); --DEBUG
						elseif(k == "filename")then
							--http://192.168.111.210/?command=delfile&filename=###
							if(delfile == "true")then delfile = "false"; print("[Delete " .. (v or "---") .. " file]"); file.remove(v); delfile = nil; --Команда удаления указанного файла
							elseif(runfile == "true")then print("[Running " .. (v or "---") .. " file]"); dofile(v); runfile = nil; --Команда запуска на исполнение указанного файла
							end
							conn:send("HTTP/1.1 204 No Content\r\nConnection: close\r\n\r\n"); --DEBUG
						elseif(k == "phymode")then
							--http://192.168.111.210/?command=setphymode&phymode=1
							if(setphymode == "true")then print("[set phymode as " .. (v or "---") .. "]"); wifi.setphymode(v); setphymode = nil; --Команда установки класса сети WiFi
							end
						elseif(k == "nullmodesleep")then
							--http://192.168.111.210/?command=setnullmodesleep&nullmodesleep=true
							if(setnullmodesleep == "true")then print("[set nullmodesleep as " .. (v or "---") .. "]"); if(v == "false")then v = false; else v = true; end wifi.nullmodesleep(v); setnullmodesleep = nil; --Команда установки класса сети WiFi
							end
						elseif(k == "sleeptype")then
							if(setsleeptype == "true")then
								print("[set sleeptype as " .. v .. "]");
								if(v == "NONE_SLEEP")then v = wifi.NONE_SLEEP;
								elseif(v == "LIGHT_SLEEP")then v = wifi.LIGHT_SLEEP;
								elseif(v == "MODEM_SLEEP")then v = wifi.MODEM_SLEEP;
								else v = wifi.MODEM_SLEEP;
								end
								wifi.sta.sleeptype(v); setsleeptype = nil; --Команда установки класса сети WiFi
							end
						end
					end
				else --Если нет параметро, а запрашивается файл для загрузки
					--Определяем тип содержимого перед отправкой запрашиваемого файла для браузера
					if(file.exists((path:match("/(.+)") or "index.htm")))then --Существует ли файл на устройстве
						if(path:find("%.htm"))then ContentType="text/html"; --Тип HTML
						elseif(path:find("%.html"))then ContentType="text/html"; --Тип HTML
						elseif(path:find("%.css"))then ContentType="text/css"; --Тип CSS
						elseif(path:find("%.js"))then ContentType="text/javascript"; --Тип JavaScript
						elseif(path:find("%.png"))then ContentType="image/png"; --Тип JavaScript
						elseif(path:find("%.gif"))then ContentType="image/gif"; --Тип JavaScript
						elseif(path:find("%.ico"))then ContentType="image/x-icon"; --Тип JavaScript
						elseif(path:find("%.jpg") or path:find("%.jpeg"))then ContentType="image/jpeg"; --Тип JavaScript
						else ContentType="text/html"; --Если файл существует но его формат здесь не описан, то определяем по умолчанию "text/html"
						end
						requestFile,pos=path:gsub("/(.+)", "%1"); --Присваиваем имя отправляемого файла переменной requestFile. pos - позиция в строке с которой найдено имяфайла. 0 - значит не найден и первый символ / (корень)
						if(pos == 0 and requestFile == "/")then requestFile="index.htm"; end --Если указан просто /, то отправляем index.htm
						print("[Sending file " .. (requestFile or "#requestFile#") .. "]");
						filePos=0; --Обнуляем позицию файла
						conn:send("HTTP/1.1 200 OK\r\nConnection: close\r\n\r\n"); --Отправляем пакет,что запрашиваемая страница существует и готовится ее отправка
						ContentType = nil;
					else --Если указан не существующий файл
						print("[File /" .. (path:gsub("/(.+)", "%1") or "!path:gsub!") .. " not found]");
						conn:send("HTTP/1.1 404 Not Found\r\n\r\n"); --Отправляем пакет,что запрашиваемая страница не найдена на локальном хранилище
						conn:close(); --Закрываем текущее соединение с клиентом
						collectgarbage(); --Высвободаем память
					end
					--^^Определяем тип содеримого перед отправкой запрашиваемого файла для браузера
				end
			elseif((method == "POST" or EndPOST == "false") and request ~= nil)then
				if(EndPOST == "true")then print("[POST]"); end --DEBUG
				--if(ContentType == nil)then ContentType = request:match("\r\nContent%-Type:%s(.-);.+"); end
				if(ContentLength == nil)then ContentLength = request:match("\r\nContent%-Length:%s(.-)\r\n"); end
				if(boundary == nil)then boundary = request:match("boundary=(.-)\r\n"); end
				if(filename == nil)then filename = request:match("filename=\"(.-)\"\r\n"); end
				if(ContentLength == nil or boundary == nil or filename == nil)then StartPOSTEnd = "false"; end

				if(StartPOST == nil and boundary ~= nil and StartPOSTEnd == "false")then
					StartPOST = request:match("(%-%-" .. escapeMagic(boundary) .. ".+\r\n\r\n).+");
					if(StartPOST ~= nil)then
						POST = request:match(escapeMagic(StartPOST) .. "(.+)\r\n%-%-" .. escapeMagic(boundary) .. "%-%-\r\n");
						if(POST ~= nil)then
							if(filename ~= nil and file.open("~" .. filename, "w+"))then
								file.write(POST);
								file.close();
								print("[Upload file " .. filename .. "]");
								print("[" .. #POST .. " bytes left]");
							end
							POST = nil;
							file.remove(filename);
							file.rename("~" .. filename, filename);
							boundary = nil;
							print("[Upload " .. filename .. " done]");
							filename = nil;
							conn:send("HTTP/1.1 204 No Content\r\nConnection: close\r\n\r\n");
							ContentLength = nil;
						else
							POST = request:match(escapeMagic(StartPOST) .. "(.+)");
							if(POST ~= nil)then
								if(filename ~= nil and file.open("~" .. filename, "w+"))then
									file.write(POST);
									file.close();
									ContentLengthOF = tonumber(ContentLengthOF) + #boundary + 2 + 2 + 2 + 2 + #StartPOST + #POST - 1;
									--														\r\n + -- + -- + \r\n                - ?
									print("[Upload file " .. filename .. "]");
									print("[" .. ContentLengthOF .. " of " .. ContentLength .. " bytes left]");
								end
								POST = nil;
								EndPOST = "false";
								StartPOSTEnd = "true";
								conn:send("HTTP/1.1 100 Continue\r\n\r\n");
								return;
							end
						end
						StartPOST = nil;
					else
						EndPOST = "false";
					end
				end
				if(EndPOST == "false" and StartPOSTEnd == "true")then --Если получение файла не окончено
					if((tonumber(ContentLengthOF) + #request) <= tonumber(ContentLength))then
						if(filename ~= nil and file.open("~" .. filename, "a+"))then
							file.write(request);
							file.close();
							ContentLengthOF = tonumber(ContentLengthOF) + #request;
							print("[" .. ContentLengthOF .. " of " .. ContentLength .. " bytes left]");
						end
						EndPOST = "false";
					else
						POST = request:sub(0, tonumber(ContentLength) - tonumber(ContentLengthOF));
						if(POST ~= nil)then
							if(filename ~= nil and file.open("~" .. filename, "a+"))then
								file.write(POST);
								file.close();
						 		ContentLengthOF = tonumber(ContentLengthOF) + string.len(request:sub(0, tonumber(ContentLength) - tonumber(ContentLengthOF))); --DEBUG
								print("[" .. ContentLengthOF .. " of " .. ContentLength .. " bytes left]");
							end
							POST = nil;
							file.remove(filename);
							file.rename("~" .. filename, filename);
							boundary = nil;
							print("[Upload " .. filename .. " done]");
							filename = nil;
							conn:send("HTTP/1.1 204 No Content\r\nConnection: close\r\n\r\n"); --DEBUG
							ContentLength = nil;
						end
					end
				end
			else
				print("[Unknow data]");
			end
			collectgarbage();
		end)
		--^^Для типа соединения на получение данных

		conn:on("sent",function(conn) --Обработка исходящих данных
			if(requestFile ~= nil)then--Если переменная с именем отправляемого файла не пустая
				if(file.open(requestFile,r))then --Открываем файл на чтение
					file.seek("set",filePos); --Перемещаем курсор чтения из файл в позицию
					local partial_data = file.read(1536); --Определяем размерность блока данных для считывания перед отправкой и считываем (512,1024,1536,1792)
					file.close(); --закрываем файл после прочтения
					if(partial_data)then --Если после чтения есть данные
						filePos = filePos + #partial_data; --Перемещаем курсор в файле на кол-во считанных данных для следующего чтения
						local partial_dataLen = #partial_data; --Запоминаем размерность текущего блока данных, т.к. если он содержит исполняемый код LUA, то после исполнения он изменился в любую сторону, а данные из файла останутся неизменными
						for S in partial_data:gmatch("<%?lua(.-)%?>") do --Ищем все исполняемые блоки кода LUA
							partial_data = partial_data:gsub("<%?lua" .. escapeMagic(S) .. "%?>",(executeCode(S) or "")); --Выполняем LUA код и вставляем результат в отправляемый код
						end;
						if(partial_data:find("<%?lua"))then --КОД НИЖЕ ДОЧИТЫВАЕТ ИЗ ФАЙЛА ДО ПОЛНОГО БЛОКА <?lua ### ?> + подменяет эти блоки результатом выполнения кода в них
							if(file.open(requestFile,r))then --Открываем файл на чтение
								local PosSeek = 64; --Дополнительно считываем блок размером ## для возможного перекрытия окончания блока "### ?>"
								while not partial_data:find("%?>") do
									file.seek("set",filePos); --Перемещаем курсор чтения на файл в позицию
									partial_data = partial_data .. file.read(PosSeek); --Определяем размерность блока данных для считывания перед отправкой и считываем
									filePos = filePos + PosSeek;
								end
								PosSeek = nil;
								file.close(); --закрываем файл после прочтения
								local FindStrBegin, FindStrEnd = partial_data:find("(.+)%?>");
								filePos = filePos - (#partial_data - FindStrEnd);
								partial_data = (partial_data:match("(.+)%?>") or "").."?>";
								for S in partial_data:gmatch("<%?lua(.-)%?>") do
									partial_data = partial_data:gsub("<%?lua" .. escapeMagic(S) .. "%?>",(executeCode(S) or "")); --Выполняем LUA код и вставляем результат в отправляемый код
								end;
								FindStrBegin = nil;
								FindStrEnd = nil;
							end
						end
						if(partial_data ~= "" and partial_data ~= nil)then --Если после исполнения кода LUA есть что передавать
							conn:send((partial_data or "")); --Отправляем переработанный код
							partial_data = nil;
							print("["..(filePos or "#filePos#").." bytes sent]");
						else
							print("[NULL DATA TO SENT!]"); --DEBUG
						end
						if(partial_dataLen == 1536)then --Если данный считанный блок текста кратный определенному блоку в начале - значит есть еще что считывать (512,1024,1536,1792)
							ConnStatus = true;
							return;
						else --Закрываем соединение,т.к. уже весь файл отправили
							print("*[Connection closed]");
							ConnStatus = conn:close();
						end
					end
				else
					print("[Error opening file "..(requestFile or "#requestFile#").."]");
				end
			end
			if(ConnStatus == true)then --Проверяем, если соединение небыло ранее закрыто, то закрываем его
				ConnStatus = conn:close();
				print("[Connection closed]");
			end
		end)
		conn:on("disconnection", function(conn, payload) --Обработка события разрыва соединения
			print("[The client broke the connection to the server] [" .. payload .. "]");
			EndPOST = "true";
			StartPOSTEnd = "false";
			ContentLengthOF = 0;
			collectgarbage();
		end)
		conn:on("reconnection", function(conn, payload) --Обработка события восстановления соединения
			print("[net.TCP server reconnection] [" .. payload .. "]");
			EndPOST = "true";
			StartPOSTEnd = "false";
			ContentLengthOF = 0;
			collectgarbage();
		end)
		-- conn:on("connection", function(conn, payload) --Обработка события установки соединения
		-- end)
	end)



end